package PI20050411;

import ProSW.*;
import java.util.*;

public abstract class Socio {
	private final String codFis;
	private final String nome, cognome;

	public Socio(String cf, String n, String c) throws EccezionePrecondizioni {
		if (cf == null || n == null || c == null)
			throw new EccezionePrecondizioni("Gli argomenti non possono essere null");
		codFis = cf; nome = n; cognome = c;
	}

	public String getCodFis() { return codFis; }
	public String getNome() { return nome; }
	public String getCognome() { return cognome; }


	// Operazioni di classe
	public abstract boolean clienteAbituale();
	protected boolean clienteAbituale(int x) {
		int num = 0;
		Iterator<TipoLinkClienteNoleggio> it = linkClienteNoleggio.iterator();
		DataOra adesso = new DataOra();
		while (it.hasNext()) {
			Noleggio n = it.next().getNoleggio();
			if (adesso.differenza(n.getInizio(), DataOra.MESI) <= 12) num++;
		}
		return num >= x;
	}

	public int classeDiRischio() {
		DataOra adesso = new DataOra();
		int nSinistri = 0;
		Iterator<TipoLinkClienteNoleggio> it = linkClienteNoleggio.iterator();
		while (it.hasNext()) {
			Noleggio n = it.next().getNoleggio();
			if (adesso.differenza(n.getInizio(), DataOra.ANNI) <= 3) {
				Iterator<TipoLinkSinistroRelativoA> itSinistri = n.linkSinistroRelativoA.iterator();
				while (itSinistri.hasNext()) {
					Sinistro s = itSinistri.next().getSinistro();

					if (!SinistroConControparte.class.isInstance(s)) {
						nsinistri++;  // Sinistro senza controparte
					}
				}
				else {
					SinistroConControparte sc = (SinistroConControparte)s;
					if (sc.getHaColpa()) nsinistri++;
					// Sinistro con controparte di cui il socio ha colpa
				}
			}
		}
		return Math.min(nsinistri, 10);
	}

	public Set<Auto> autoPreferite() {
		Set<Auto> A = new HashSet<Auto>();
		Iterator<TipoLinkClienteNoleggio> it = linkClienteNoleggio.iterator();
		while(it.hasNext()) {
			TipoLinkClienteNoleggio t = it.next();
			Noleggio n = t.getNoleggio();
			TipoLinkAutoNoleggiata tan = n.getLinkAutoNoleggiata();
			A.add(tan.getAuto());
		}
		// L'insieme "A" contiene tutte le auto noleggiate
		// Devo trovare le preferite
		Set<Auto> result = new HashSet<Auto>();
		int maxVolte = 0;
		Iterator<Auto> itAuto = A.iterator();
		while (itAuto.hasNext()) {
			Auto a = itAuto.next();
			int quanteVolteQuesta = 0;
			Iterator<TipoLinkAutoNoleggiata> itAN = a.getLinkAutoNoleggiata().iterator();
			while(itAN.hasNext()) {
				Noleggio na = it.next().getNoleggio();
				Socio s = na.getLinkClienteNoleggio().getSocio();
				if (s == this) quanteVolteQuesta++;
			}
			if (quanteVolteQuesta < maxVolte) continue;
			else if (quanteVolteQuesta == maxVolte) result.add(a);
			else {
				result = new HashSet<Auto>(); // oppure result.clear()
				result.add(a);
				maxVolte = quanteVolteQuesta;
			}
		}
		return result;
	}

	public double importoDovuto(DataOra da, DataOra a) throws EccezionePrecondizioni {
		if (da == null || a == null) throw new EccezionePrecondizioni("Gli argomenti non possono essere null");
		if (a.primaDi(da) || (new DataOra()).primaDi(a)) throw new EccezionePrecondizioni("Il periodo di tempo non e' valido");
		double importoBase = 0;

		Iterator<TipoLinkClienteNoleggio> it = linkClienteNoleggio.iterator();
		while (it.hasNext()) {
			TipoLinkClienteNoleggio t = it.next();
			Noleggio n = t.getNoleggio();
			if ( da.primaDiOUgualeA(n.getInizio()) &&
				 n.getInizio().primaDi(a)
			) {
				importoBase += n.prezzo();
			}
		}
		if (!clienteAbituale()) return importoBase;
		else return importoBase * 0.85;
	}
	
	// Gestione associazioni: lasciata per esercizio...
} //:~