package PI20050411;

import ProSW.*;
import java.util.*;


public final class VerificheConvenzioni {

	private VerificheConvenzioni() {}

	public static Set<Societa> societaConPiuConvVantaggiose(Categoria c) throws EccezionePrecondizioni {
		if (c==null) throw new EccezionePrecondizioni("...");
		Set<Convenzione> ccMax = new HashSet<Convenzione>();
		int maxSconto = 0;

		Iterator<TipoLinkConvenzioneRelativaA> it = c.getLinkConvenzioneRelativaA().iterator();

		while(it.hasNext()) {
			ConvenzioneCategorie cc = it.next().getConvenzioneCategorie();
			if (cc.getSconto() < maxSconto) continue;
			else if (cc.getSconto() == maxSconto) {
				ccMax.add(cc);
			}
			else {
				ccMax = new HashSet<Convenzione>();
				ccMax.add(cc);
				maxSconto = cc.getSconto();
			}
		}
		Set<Societa> result = new HashSet<Societa>();
		Iterator<Convenzione> itConv = ccMax.iterator();
		while (itConv.hasNext()) {
			Convenzione conv = itConv.next();
			Iterator<TipoLinkHaConvenzione> itSoc = conv.getLinkHaConvenzione().iterator();
			while (itSoc.hasNext()) {
				result.add( itSoc.next().getSocieta() );
			}
		}
		return result;
	}


	public static Set<Societa> almenoUnaConvenzioneEco(Set<Societa> societa) throws EccezionePrecondizioni {
		if (societa==null) throw new EccezionePrecondizioni("...");
		Set result = new HashSet<Societa>();

		Iterator<Societa> it = societa.iterator();
		while (it.hasNext()) {
			Societa s = it.next();
			Iterator<TipoLinkHaConvenzione> itConv = s.getLinkHaConvenzione().iterator();
			while (itConv.hasNext()) {
				Convenzione c = it.next().getConvenzione();
				if (ConvenzioneEcocompatibili.class.isInstance(c)) {
					result.add(s);
					break;
				}
			}
		}
		return result;
	}

} //:~